/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *									Toyohashi Univ. of Technology, JAPAN
 *	Copyright (C) 2007		by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2008-2010 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	Copyright (C) 2011-2012	by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *
 *	$Id: start.S 2083 2011-05-12 07:59:25Z mit-kimai $
 */

/*
 *	ͥбΥȥåץ⥸塼(SH12A)
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val) 	(val)		 /* uint_tޥ */
#define ULONG_C(val)	(val)		 /* ulong_tޥ */
#define CAST(type, val) (val)		 /* 㥹ȤԤޥ */
#include "kernel_impl.h"

	.section .text_kernel
	.global _start
	.align	2
_start:
	/*
	 *	SR롣
	 *	ߥåȤ롣
	 */
	mov.l  _iipm_disall_start, r0
	ldc    r0, sr

	/*
	 *	󥿥ƥѤΥåν
	 */
	mov.l  _kernel_istkpt_p, r1
	mov.l  @r1, r15

	/*
	 *	_hardware_init_hook ƤӽФ(0Ǥʤ)
	 *
	 *	åȥϡɥ˰¸ɬפʽϡ
	 *	hardware_init_hookȤؿѰդ롥
	 */
start_0:
	mov.l  _hardware_init_hook_start, r0
	tst    r0, r0
	bt	   start_1
#ifdef TOPPERS_SUPPORT_SH2A_INSTRUCTION
	jsr/n  @r0
#else /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	jsr    @r0
	 nop
#endif /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	
	/*
	 * bss򥯥ꥢ
	 *
	 *	ƥ4Хȶ֤ƤΤǡ
	 *	_end4ХȶǤʤȤƤ⡢
	 *	٤Υ񤭤뤳ȤϤʤ
	 *	ʲdataνƱ͡
	 */
start_1:
    mov.l   __kernel_bsssecinib_table_sta, r0 /* ơ֥Υɥ쥹 */
    mov   #0, r1 /* ơ֥Υǥå: i */
    mov.l   __kernel_tnum_bsssec_sta, r2 
    mov.l   @r2, r2 /* ơ֥ǿ: num */
	mov   #0, r3 /*  */
start_bss_2:
    cmp/hi  r1, r2 /* 롼׽λȽ: i < num */
    bf      start_3
    mov.l   @(0,r0), r4 /* bssƬ */
    mov.l   @(4,r0), r5 /* bssνλ */
	cmp/hs  r5, r4      /* bss */
	bt	    start_bss_4 /* ʤмbss */
    nop
start_bss_3:
    /*
     *  bssΰϡ4byte˥饤󤵤Ƥ
     *  äơ4byteĥǡ򥳥ԡƤ
     */
	mov.l   r3, @r4     /* bssΰ0ǽ */
	add     #4, r4      /* Ϥ */
	cmp/hi  r4, r5      /* bssνλϤޤ褿 */
	bt      start_bss_3 /* λϤʤнλ */
    nop
start_bss_4:
    add     #8, r0 /* ơ֥Υɥ쥹򥤥󥯥 4byte * 2 -> 8 */
    add     #1, r1 /* ơ֥Υǥå򥤥󥯥: i++ */
    bra     start_bss_2
    nop

    .align 4
    .global __kernel_bsssecinib_table
    .global __kernel_tnum_bsssec
__kernel_bsssecinib_table_sta:
    .long   __kernel_bsssecinib_table
__kernel_tnum_bsssec_sta:
    .long   __kernel_tnum_bsssec

	/*
	 *	dataROMбˡ
	 *
	 *	__idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *	ԡ롥
	 */
start_3:
#ifndef TOPPERS_OMIT_DATA_INIT
    mov.l   __kernel_datasecinib_table_sta, r0 /* ơ֥Υɥ쥹 */
    mov     #0, r1 /* ơ֥Υǥå: i */
    mov.l   __kernel_tnum_datasec_sta, r2
    mov.l   @r2, r2 /* ơ֥ǿ: num */
start_data_2:
    cmp/hi  r1, r2 /* 롼׽λȽ: i < num */
    bf      start_5
    mov.l   @(0,r0), r3 /* dataƬ -> ѿɥ쥹 */
    mov.l   @(4,r0), r4 /* dataνλ */
    mov.l   @(8,r0), r5 /* idataƬ -> ͤΥɥ쥹 */
	cmp/hs  r4, r3      /* data */
	bt	    start_data_4    /* ʤмdata */
    nop
start_data_3:
    /*
     *  idataΰϡROMΰΤᡤ饤󤵤ʤ
     *  äơ1byteĥǡ򥳥ԡƤ
     */
	mov.b   @r5, r6         /* idataͤ */
    mov.b   r6, @r3         /* idataͤdataΥɥ쥹إȥ */
	add     #1, r3          /* dataμϤ */
	add     #1, r5          /* idataμϤ */
	cmp/hi  r3, r4          /* dataνλϤޤ褿 */
	bt      start_data_3    /* λϤʤнλ */
    nop
start_data_4:
    add     #12, r0 /* ơ֥Υɥ쥹򥤥󥯥 4byte * 3 -> 12 */
    add     #1, r1 /* ơ֥Υǥå򥤥󥯥: i++ */
    bra     start_data_2
    nop

    .align 4
    .global __kernel_datasecinib_table
    .global __kernel_tnum_datasec
__kernel_datasecinib_table_sta:
    .long   __kernel_datasecinib_table
__kernel_tnum_datasec_sta:
    .long   __kernel_tnum_datasec
#endif /* TOPPERS_OMIT_DATA_INIT */

	/*
	 *	_software_init_hook ƤӽФ0 Ǥʤˡ
	 *
	 *	եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *	ϡsoftware_init_hook ȤؿѰդ
	 *	褤
	 */
start_5:
	mov.l  _software_init_hook_start, r0
	tst    r0, r0
	bt	   start_6
#ifdef TOPPERS_SUPPORT_SH2A_INSTRUCTION
	jsr/n  @r0
#else /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	jsr    @r0
	 nop
#endif /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */

start_6:
    /*
     *  åνSH2Aͭsh7211
     *  
     *  åνϥå̵֤ǹԤɬפ뤿ᡢ
     *  ؿƤӽФκݤˡʬ襢ɥ쥹Υӥå29򥻥åȤƤ롣
     *  0x2000,0000or黻ƤΤϡǽ餫_cache_init
     *  å̵֤˥ޥåԥ󥰤Ƥк
     *  
     *  ɥ쥹ޥåסʳΤȴˡ
     *  0x0000,0000 - 0x1fff,ffffåͭ
     *  0x2000,0000 - 0x3fff,ffffå̵֡ʥɡ֡
     */
#ifdef ENABLE_CACHE
	mov.l  _cache_init_p, r1
	mov.l  _non_cachable_addr_top, r2
	or     r2, r1
	jsr/n  @r1			/*  SH2AͭνʤΤǡjsr/n̿᤬ѤǤ  */
#endif /* ENABLE_CACHE */

	/*
	 *	ͥư
	 */
	mov.l  _sta_ker_start, r0
#ifdef TOPPERS_SUPPORT_SH2A_INSTRUCTION
	jsr/n  @r0
#else /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */
	jsr    @r0
	 nop
#endif /* TOPPERS_SUPPORT_SH2A_INSTRUCTION */

    /*
     *  åνSH2Aͭsh7211
     */
#ifdef ENABLE_CACHE
_cache_init:
    mov.l _ccr1_addr, r1
								/*  å塦եå  */
    movi20 #(CCR1_ICF | CCR1_OCF), r0
    mov.l r2, @r1
    mov.l _ccr_init_val, r2		/*  ͤϥåȰ¸  */
    mov.l r2, @r1
    mov.l @r1, r2				/*  ߡ꡼  */
    rts/n						/*  ǰΤᡢٱ䥹åȤˤ֤ʤ*/
#endif /* ENABLE_CACHE */

	.align 2
_iipm_disall_start:
	.long IIPM_DISALL
_kernel_istkpt_p:
	.long __kernel_istkpt
_hardware_init_hook_start:
	.long _hardware_init_hook
_software_init_hook_start:
	.long _software_init_hook
_sta_ker_start:
	.long _sta_ker

#ifdef ENABLE_CACHE
_cache_init_p:
	.long _cache_init
_non_cachable_addr_top:
	.long 0x20000000
_ccr1_addr:
	.long CCR1
_ccr_init_val:
	.long CCR1_INIT			/*  ͤϥåȰ¸  */
#endif /* ENABLE_CACHE */


/*
 *  HEWI/Oߥ졼ǽθƤӽФ
 *  
 *  ϡsys_support.S˵Ҥ٤
 *  󥯸_hew_io_sim_bodyΥɥ쥹
 *  ץꥱˤ餺ˤ뤿ᡢ
 *  ȥåץ롼ľ֤Ƥ롣
 *  
 *  
 *  ʲξ֤ǸƤФ롣
 *  r4ǽ
 *  r5ѥ᡼֥åؤΥݥ
 */
#ifdef TOPPERS_HEW_SIMULATOR

    .section .text
    .align 2        
    .global _hew_io_sim
_hew_io_sim:
	mov   r4, r0			/*  ǽ  */
	mov   r5, r1			/*  ѥ᡼֥åؤΥݥ  */
	mov.l _hew_io_sim_body_addr, r3
    sts.l pr,@-r15
	jsr   @r3
	nop
    lds.l @r15+,pr
    rts
     nop

/*
 *  Υɥ쥹ʬ뤳ȤǡHEWI/Oߥ졼ǽ
 *  ưȥꥬȤʤ롣
 *  
 */
_hew_io_sim_body:
    rts
     nop
	
	.align  4
_hew_io_sim_body_addr:
    .long  _hew_io_sim_body

#endif	/*  TOPPERS_HEW_SIMULATOR  */

