/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MPUɥ饤СSH72AWѡ
 */

#ifndef TOPPERS_TARGET_MPU_H
#define TOPPERS_TARGET_MPU_H

#define MPCMPEN    0xfff78000 /* MPUͭ */
#define MPCRACR    0xfff78010 /* R */
#define MPCWACR    0xfff78014 /* W */
#define MPCIACR    0xfff78018 /* I(X) */
#define MPCVLD     0xfff7801c /* ΰͭ */
#define MPCACBCR   0xfff78020 /* ХåΰΥ */
#define MPCECLR    0xfff78024 /* 顼ꥢ */
#define MPCESR     0xfff78028 /* 顼ơ */
#define MPCHITI    0xfff78034 /* ̿ҥå */
#define MPCHITO    0xfff78038 /* ǡҥåȡΰ襵ҥå */
#define MPCHITO_R_MASK 0x00000008 /* Rĥե饰 */
#define MPCHITO_W_MASK 0x00000004 /* Wĥե饰 */
#define MPCHITO_I_MASK 0x00000002 /* Iĥե饰 */
#define MPCRSADR   0xfff7803c /* ΰ襵ɥ쥹 */
#define MPCRSOP    0xfff78040 /* ΰ襵 */
#define MPCRSOP_S_BIT    0x01 /* ΰ襵ϥӥå */   
#define MPCERADRI  0xfff7802c /* ̿ᥢ顼ɥ쥹 */
#define MPCERADRO  0xfff78030 /* ǡ顼ɥ쥹 */

#define MPCSADR0   0xfff78100 /* ΰ0 ϥɥ쥹 */
#define MPCSADR1   0xfff78110 /* ΰ1 ϥɥ쥹 */
#define MPCSADR2   0xfff78120 /* ΰ2 ϥɥ쥹 */
#define MPCSADR3   0xfff78130 /* ΰ3 ϥɥ쥹 */
#define MPCSADR4   0xfff78140 /* ΰ4 ϥɥ쥹 */
#define MPCSADR5   0xfff78150 /* ΰ5 ϥɥ쥹 */
#define MPCSADR6   0xfff78160 /* ΰ6 ϥɥ쥹 */
#define MPCSADR7   0xfff78170 /* ΰ7 ϥɥ쥹 */
#define MPCSADR8   0xfff78180 /* ΰ8 ϥɥ쥹 */
#define MPCSADR9   0xfff78190 /* ΰ9 ϥɥ쥹 */
#define MPCSADR10  0xfff781a0 /* ΰ10ϥɥ쥹 */
#define MPCSADR11  0xfff781b0 /* ΰ11ϥɥ쥹 */
#define MPCSADR12  0xfff781c0 /* ΰ12ϥɥ쥹 */
#define MPCSADR13  0xfff781d0 /* ΰ13ϥɥ쥹 */
#define MPCSADR14  0xfff781e0 /* ΰ14ϥɥ쥹 */
#define MPCSADR15  0xfff781f0 /* ΰ15ϥɥ쥹 */

#define MPCEADR0   0xfff78104 /* ΰ0 λɥ쥹 */
#define MPCEADR1   0xfff78114 /* ΰ1 λɥ쥹 */
#define MPCEADR2   0xfff78124 /* ΰ2 λɥ쥹 */
#define MPCEADR3   0xfff78134 /* ΰ3 λɥ쥹 */
#define MPCEADR4   0xfff78144 /* ΰ4 λɥ쥹 */
#define MPCEADR5   0xfff78154 /* ΰ5 λɥ쥹 */
#define MPCEADR6   0xfff78164 /* ΰ6 λɥ쥹 */
#define MPCEADR7   0xfff78174 /* ΰ7 λɥ쥹 */
#define MPCEADR8   0xfff78184 /* ΰ8 λɥ쥹 */
#define MPCEADR9   0xfff78194 /* ΰ9 λɥ쥹 */
#define MPCEADR10  0xfff781a4 /* ΰ10λɥ쥹 */
#define MPCEADR11  0xfff781b4 /* ΰ11λɥ쥹 */
#define MPCEADR12  0xfff781c4 /* ΰ12λɥ쥹 */
#define MPCEADR13  0xfff781d4 /* ΰ13λɥ쥹 */
#define MPCEADR14  0xfff781e4 /* ΰ14λɥ쥹 */
#define MPCEADR15  0xfff781f4 /* ΰ15λɥ쥹 */

#define MPCACR0    0xfff78108 /* ΰ0  */
#define MPCACR1    0xfff78118 /* ΰ1  */
#define MPCACR2    0xfff78128 /* ΰ2  */
#define MPCACR3    0xfff78138 /* ΰ3  */
#define MPCACR4    0xfff78148 /* ΰ4  */
#define MPCACR5    0xfff78158 /* ΰ5  */
#define MPCACR6    0xfff78168 /* ΰ6  */
#define MPCACR7    0xfff78178 /* ΰ7  */
#define MPCACR8    0xfff78188 /* ΰ8  */
#define MPCACR9    0xfff78198 /* ΰ9  */
#define MPCACR10   0xfff781a8 /* ΰ10 */
#define MPCACR11   0xfff781b8 /* ΰ11 */
#define MPCACR12   0xfff781c8 /* ΰ12 */
#define MPCACR13   0xfff781d8 /* ΰ13 */
#define MPCACR14   0xfff781e8 /* ΰ14 */
#define MPCACR15   0xfff781f8 /* ΰ15 */

#define PAGE_SIZE 4
#define MPCADR_mpcsadr0     0x00
#define MPCADR_mpceadr0     0x04
#define MPCADR_mpcsadr1     0x10
#define MPCADR_mpceadr1     0x14
#define MPCADR_mpcsadr2     0x20
#define MPCADR_mpceadr2     0x24
#define MPCADR_mpcsadr3     0x30
#define MPCADR_mpceadr3     0x34
#define MPCADR_mpcsadr4     0x40
#define MPCADR_mpceadr4     0x44
#define MPCADR_mpcsadr5     0x50
#define MPCADR_mpceadr5     0x54
#define MPCADR_mpcsadr6     0x60
#define MPCADR_mpceadr6     0x64
#define MPCADR_mpcsadr7     0x70
#define MPCADR_mpceadr7     0x74
#define MPCADR_mpcsadr8     0x80
#define MPCADR_mpceadr8     0x84
#define MPCADR_mpcsadr9     0x90
#define MPCADR_mpceadr9     0x94
#define MPCADR_mpcsadr10    0xa0
#define MPCADR_mpceadr10    0xa4
#define MPCADR_mpcsadr11    0xb0
#define MPCADR_mpceadr11    0xb4
#define MPCADR_mpcsadr12    0xc0
#define MPCADR_mpceadr12    0xc4
#define MPCADR_mpcsadr13    0xd0
#define MPCADR_mpceadr13    0xd4
#define MPCADR_mpcsadr14    0xe0
#define MPCADR_mpceadr14    0xe4
#define MPCADR_mpcsadr15    0xf0
#define MPCADR_mpceadr15    0xf4

#define OMIT_PROBE_MEM_WRITE
#define OMIT_PROBE_MEM_READ
#define OMIT_PROBE_STACK

#ifndef TOPPERS_MACRO_ONLY

extern void target_mpu_initialize(void);
extern void target_mpu_exc_handler(void *p_excinf);
// 㳰¹Գϻåϥɥ
extern void target_emulate_texrtn_handler(void *p_excinf);
// 㳰꥿åϥɥ
extern void target_emulate_ret_tex_handler(void *p_excinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_MPU_H */
